/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy;

import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.t2framework.commons.util.Assertion;
import org.t2framework.commons.util.CollectionsUtil;
import org.t2framework.commons.util.Reflections.ClassUtil;

/**
 * <#if locale="en">
 * <p>
 * Utility class for {@link Lucy}.This class is not expected to use by
 * application developer.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public class LucyUtil {

	private static Set<Class<?>> simpleTypes = CollectionsUtil.newHashSet();

	static {
		simpleTypes.add(String.class);
		simpleTypes.add(Number.class);
		simpleTypes.add(Date.class);
		simpleTypes.add(java.sql.Date.class);
		simpleTypes.add(Calendar.class);
		simpleTypes.add(List.class);
		simpleTypes.add(Map.class);
		simpleTypes.add(Set.class);
		simpleTypes.add(Lucy.class);
	};

	/**
	 * <#if locale="en">
	 * <p>
	 * Check if the class is simple type or not.Simple type means it is not
	 * needed dependency injecting process which will occur at component
	 * building process at {@link Lucy}.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param c
	 * @return
	 */
	public static boolean isSimpleType(Class<?> c) {
		Class<?> clazz = ClassUtil.toWrapperClass(Assertion.notNull(c));
		for (Class<?> candidate : simpleTypes) {
			if (candidate.isAssignableFrom(clazz)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * <#if locale="en">
	 * <p>
	 * Add type.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param type
	 */
	public static void addSimpleTypes(Class<?> type) {
		simpleTypes.add(Assertion.notNull(type));
	}
}
