/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop;

import java.util.List;
import java.util.Map;

import org.t2framework.commons.aop.spi.Aspect;

/**
 * <#if locale="en">
 * <p>
 * Aspect descriptor interface.It has original class, enhanced class, name,
 * aspects.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 */
public interface AspectDesc {

	/**
	 * <#if locale="en">
	 * <p>
	 * Get original class.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	Class<?> getOriginalClass();

	/**
	 * <#if locale="en">
	 * <p>
	 * Get enhanced class.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	Class<?> getEnhancedClass();

	/**
	 * <#if locale="en">
	 * <p>
	 * Get enhanced class name.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	String getEnhancedClassName();

	/**
	 * <#if locale="en">
	 * <p>
	 * Set enhanced class.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param enhancedClass
	 */
	void setEnhancedClass(Class<?> enhancedClass);

	/**
	 * <#if locale="en">
	 * <p>
	 * Set enhanced class name.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param name
	 */
	void setEnhancedClassName(String name);

	/**
	 * <#if locale="en">
	 * <p>
	 * Get list of {@link Aspect}.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	List<Aspect> getAspects();

	/**
	 * <#if locale="en">
	 * <p>
	 * Get parameters.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	Map<String, Object> getParameters();

	/**
	 * <#if locale="en">
	 * <p>
	 * If target is interface or not.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	boolean isInterfaceTarget();

}
