/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop;

/**
 * <#if locale="en">
 * <p>
 * {@link EnhancedClassCache} is simple cache interface of enhanced class.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public interface EnhancedClassCache {

	/**
	 * <#if locale="en">
	 * <p>
	 * Get enhanced class from cache.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param <T>
	 * @param originalClass
	 * @return
	 */
	<T> Class<? extends T> get(Class<? extends T> originalClass);

	/**
	 * <#if locale="en">
	 * <p>
	 * Cache enhanced class.The original class is the key of cache.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param <T>
	 * @param originalClass
	 * @param enhancedClass
	 */
	<T> void cache(Class<? extends T> originalClass,
			Class<? extends T> enhancedClass);

	/**
	 * <#if locale="en">
	 * <p>
	 * Clear cache for the original class.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param <T>
	 * @param originalClass
	 */
	<T> void clear(Class<? extends T> originalClass);

	/**
	 * <#if locale="en">
	 * <p>
	 * Clear all cache.
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 */
	void clear();
}
