/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.config.impl;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.meta.ExpressionAware;
import org.t2framework.commons.meta.impl.ExpressionAwareImpl;
import org.t2framework.lucy.aop.config.AspectConfig;
import org.t2framework.lucy.config.meta.impl.AbstractOuterConfig;

/**
 * <#if locale="en">
 * <p>
 * Abstract aspect config class.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public abstract class AbstractAspectConfig extends AbstractOuterConfig
		implements AspectConfig {

	protected ExpressionAware delegate = new ExpressionAwareImpl();

	public AbstractAspectConfig() {
		super(AspectConfig.class);
	}

	@Override
	public Class<? extends AspectConfig> getType() {
		return AspectConfig.class;
	}

	@Override
	public void add(Expression<?> expression) {
		this.delegate.add(expression);
	}

	@Override
	public Iterable<Expression<?>> getExpressions() {
		return this.delegate.getExpressions();
	}

	@Override
	public boolean hasExpression() {
		return delegate.hasExpression();
	}
}
