/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.javassist.meta.impl;

public class AnnotationWriterUtil {

	public static void writeStringBody(Object value, StringBuilder body) {
		body.append("{return \"");
		body.append(value);
		body.append("\";}");
	}

	public static void writeClassBody(Object value, StringBuilder body) {
		body.append("{return ");
		body.append(value.getClass().getName());
		body.append(".class;}");
	}

	@SuppressWarnings("unchecked")
	public static void writeEnumBody(Object value, StringBuilder body) {
		if (Enum.class.isAssignableFrom(value.getClass()) == false) {
			throw new IllegalStateException();
		}
		final Enum e = (Enum) value;
		final String name = e.getDeclaringClass().getName();
		body.append("{return ");
		body.append(name + "." + value.toString());
		body.append(";}");
	}

	public static void writeObjectBody(Object value, StringBuilder body) {
		body.append("{return ");
		body.append(value);
		body.append(";}");
	}

}
