/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.javassist.util;

import java.util.Map;

import org.t2framework.commons.util.Assertion;
import org.t2framework.commons.util.CollectionsUtil;
import org.t2framework.commons.util.Reflections.ClassLoaderUtil;

import javassist.LoaderClassPath;

/**
 * <#if locale="en">
 * <p>
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 */
public class ClassPoolUtil {

	protected static Map<ClassLoader, LucyClassPool> cache = CollectionsUtil
			.newSynchronizedWeakHashMap();

	public static LucyClassPool getClassPool(final Class<?> clazz) {
		Assertion.notNull(clazz);
		ClassLoader classLoader = ClassLoaderUtil.getClassLoader(clazz);
		LucyClassPool pool = cache.get(classLoader);
		if (pool != null) {
			return pool;
		}
		pool = new LucyClassPool();
		pool.appendClassPath(new LoaderClassPath(classLoader));
		cache.put(classLoader, pool);
		return pool;
	}

	public static void clearCache() {
		cache.clear();
	}

}
