/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.meta.impl;

import java.lang.annotation.Annotation;

import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.commons.meta.Config;
import org.t2framework.commons.meta.ConfigContainer;
import org.t2framework.commons.meta.ConfigPrepareCallback;
import org.t2framework.commons.meta.ConfigType;

public abstract class AbstractOuterConfig implements Config {

	protected OuterConfigDelegate delegate;

	public AbstractOuterConfig(Class<?> type) {
		this(type, ConfigType.OUTER);
	}

	public AbstractOuterConfig(Class<?> type, ConfigType configType) {
		delegate = new OuterConfigDelegate(type, configType);
	}

	public AbstractOuterConfig(Class<?> type, ConfigType configType,
			ConfigContainer configContainer) {
		delegate = new OuterConfigDelegate(type, configType, configContainer);
	}

	@Override
	public Annotation getAnnotation() {
		return delegate.getAnnotation();
	}

	@Override
	public ConfigType getConfigType() {
		return delegate.getConfigType();
	}

	@Override
	public boolean hasAnnotation() {
		return delegate.hasAnnotation();
	}

	@Override
	public Class<?> getType() {
		return delegate.getType();
	}

	@Override
	public ConfigContainer getConfigContainer() {
		return delegate.getConfigContainer();
	}

	@Override
	public void prepare(ConfigPrepareCallback callback, BeanDesc<?> beanDesc) {
		// no op;
	}

}
