package org.t2framework.lucy.config.meta.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.commons.meta.Config;
import org.t2framework.commons.meta.ConfigType;
import org.t2framework.commons.meta.MethodDesc;
import org.t2framework.lucy.config.meta.OrderedConfig;

public class OrderedConfigImpl extends AbstractOuterConfig implements
		OrderedConfig {

	protected List<OrderedPack> packs = new ArrayList<OrderedPack>();

	protected MethodDesc targetMethodDesc;

	public OrderedConfigImpl(BeanDesc<?> beanDesc, MethodDesc md) {
		super(OrderedConfig.class, ConfigType.OUTER, beanDesc);
		this.targetMethodDesc = md;
	}

	@Override
	public void addConfig(MethodDesc md, Config config) {
		System.out.println(md.getMethodName() + " : " + config);
		OrderedPack pack = new OrderedPack();
		pack.methodDesc = md;
		pack.config = config;
		this.packs.add(pack);
	}

	@Override
	public Iterator<OrderedConfig.OrderedPack> iterator() {
		return this.packs.iterator();
	}

	@Override
	public MethodDesc getTargetMethodDesc() {
		return this.targetMethodDesc;
	}

}
