/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.el.spi.ExpressionFactory;
import org.t2framework.commons.util.StringUtil;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.LucyBootstrap;
import org.t2framework.lucy.module.LucyCoreModule;

/**
 * <#if locale="en">
 * <p>
 * The base class of {@link ExpressionHandler}.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public abstract class AbstractExpressionHandler implements
		ExpressionHandler<Lucy> {

	@Override
	public final ExpressionFactory<Lucy> getExpressionFactory() {
		return LucyBootstrap.getModule(LucyCoreModule.class)
				.getExpressionFactory();
	}

	protected Expression<Lucy> getExpression(String body) {
		if (StringUtil.isEmpty(body)) {
			return null;
		}
		return getExpressionFactory().createExpression(body);
	}

	@Override
	public Object evaluateExpression(XmlEventContext context, String evalString) {
		Expression<Lucy> e = getExpression(evalString);
		return (e != null) ? e.evaluate(context.getLucy()) : null;
	}

}
