/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

import org.t2framework.commons.meta.Config;
import org.t2framework.commons.meta.impl.AbstractConfigContainer;
import org.t2framework.commons.meta.impl.ClassDescImpl;
import org.t2framework.commons.util.StringUtil;
import org.t2framework.commons.util.Traverser;
import org.t2framework.commons.util.Reflections.ClassUtil;
import org.t2framework.commons.util.Traversal.ClassHandler;
import org.t2framework.lucy.config.meta.ConfigurableBeanDesc;
import org.t2framework.lucy.config.meta.InstanceConfig;
import org.t2framework.lucy.config.meta.InstanceConfigFactory;
import org.t2framework.lucy.config.stax.LucyConfigTagHandler.LucyConfig;

/**
 * <#if locale="en">
 * <p>
 * Components tag handler.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
@Deprecated
public class ComponentsTagHandler implements XmlEventHandler {

	@Override
	public void start(XmlEventContext context, Attributes attributes) {
		Components components = new Components();
		String packageName = attributes.getValue("package");
		if (!StringUtil.isEmpty(packageName)) {
			components.setPackageName(packageName);
		}
		String classPattern = attributes.getValue("classPattern");
		if (!StringUtil.isEmpty(classPattern)) {
			components.setClassPattern(classPattern);
		}
		String ignorePattern = attributes.getValue("ignorePattern");
		if (!StringUtil.isEmpty(ignorePattern)) {
			components.setIgnorePattern(ignorePattern);
		}
		String referenceClass = attributes.getValue("referenceClass");
		if (!StringUtil.isEmpty(referenceClass)) {
			components.setReferenceClass(ClassUtil.forName(referenceClass));
		}
		String instance = attributes.getValue("instance");
		if (StringUtil.isEmpty(instance)) {
			instance = InstanceConfigFactory.DEFAULT;
		}
		InstanceConfig instanceConfig = InstanceConfigFactory
				.getInstanceConfig(instance);
		components.addConfig(instanceConfig);
		context.push(components);
	}

	@Override
	@SuppressWarnings("unchecked")
	public void end(XmlEventContext context, String body) {
		final Components components = (Components) context.pop();
		final LucyConfig config = (LucyConfig) context.peek();
		final Traverser traverser = new Traverser(components.getPackageName(),
				new String[] { components.getClassPattern() },
				new String[] { components.getIgnorePattern() }, components
						.getReferenceClass());
		traverser.traverse(new ClassHandler() {
			@Override
			public void processClass(String packageName, String shortClassName) {
				String className = packageName + "." + shortClassName;
				Class<?> c = ClassUtil.forNameNoException(className);
				if (c == null) {
					return;
				}
				ConfigurableBeanDesc beanDesc = new ConfigurableBeanDesc(
						new ClassDescImpl(c));
				for (Config cd : components) {
					beanDesc.addConfig(cd);
				}
				config.addBeanDesc(beanDesc);
			}
		});
	}

	public static class Components extends AbstractConfigContainer {

		protected String packageName;

		protected String classPattern;

		protected String ignorePattern;

		protected Class<?> referenceClass;

		public String getPackageName() {
			return packageName;
		}

		public void setPackageName(String packageName) {
			this.packageName = packageName;
		}

		public String getClassPattern() {
			return classPattern;
		}

		public void setClassPattern(String classPattern) {
			this.classPattern = classPattern;
		}

		public String getIgnorePattern() {
			return ignorePattern;
		}

		public void setIgnorePattern(String ignorePattern) {
			this.ignorePattern = ignorePattern;
		}

		public Class<?> getReferenceClass() {
			return referenceClass;
		}

		public void setReferenceClass(Class<?> referenceClass) {
			this.referenceClass = referenceClass;
		}

	}
}
