/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

import org.t2framework.commons.el.spi.ExpressionFactory;

/**
 * <#if locale="en">
 * <p>
 * ExpressionHandler is an interface for creating and evaluating expression.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 * @param <C>
 *            as container.
 */
public interface ExpressionHandler<C> {

	/**
	 * <#if locale="en">
	 * <p>
	 * Get {@link ExpressionFactory}.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @return
	 */
	ExpressionFactory<C> getExpressionFactory();

	/**
	 * <#if locale="en">
	 * <p>
	 * Evaluate expression. If evalString is null or empty, simply return null
	 * and inherited class takes responsible for whatever it takes.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param context
	 * @param evalString
	 * @return
	 */
	Object evaluateExpression(XmlEventContext context, String evalString);
}
