/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

/**
 * 
 * <#if locale="en">
 * <p>
 * Tag handler for StAX. Implementation of {@link XmlEventHandler} should be
 * created by each tag.
 * </p>
 * <#else>
 * <p>
 * StAXを処理するためのタグハンドラです．
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public interface XmlEventHandler {

	/**
	 * <#if locale="en">
	 * <p>
	 * Hook point for starting tag.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param context
	 * @param attributes
	 */
	void start(XmlEventContext context, Attributes attributes);

	/**
	 * <#if locale="en">
	 * <p>
	 * Hook point for ending tag.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param context
	 * @param body
	 */
	void end(XmlEventContext context, String body);
}
