/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.el;

import java.util.ArrayList;
import java.util.List;

import org.t2framework.commons.el.Expression;
import org.t2framework.commons.meta.ExpressionAware;
import org.t2framework.lucy.Lucy;

/**
 * <#if locale="en">
 * <p>
 * {@link ExpressionUtil} is an utility class of evaluating all expression that
 * {@link ExpressionAware} instance has.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 */
public class ExpressionUtil {

	/**
	 * <#if locale="en">
	 * <p>
	 * Evaluate all expression.
	 * 
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 * 
	 * @param aware
	 * @param lucy
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static Object[] evaluateExpression(ExpressionAware aware, Lucy lucy) {
		List objects = new ArrayList();
		for (Expression expression : aware.getExpressions()) {
			objects.add(expression.evaluate(lucy));
		}
		return objects.toArray(new Object[objects.size()]);
	}

}
