/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.el.mvel;

import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.t2framework.lucy.Lucy;

/**
 * <#if locale="en">
 * <p>
 * Lucy map for mvel.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 */
public class LucyComponentMap implements Map<String, Object> {

	public static final String KEY_LUCY = "lucy";

	protected Lucy lucy;

	protected Map<Object, Object> context = new HashMap<Object, Object>();

	public LucyComponentMap(Lucy lucy) {
		this.lucy = lucy;
	}

	@Override
	public void clear() {
	}

	@Override
	public boolean containsKey(Object key) {
		return KEY_LUCY.equals(key) || lucy.getBeanDesc(key) != null
				|| context.containsKey(key);

	}

	@Override
	public boolean containsValue(Object value) {
		return false;
	}

	@Override
	public Set<java.util.Map.Entry<String, Object>> entrySet() {
		return Collections.emptySet();
	}

	@Override
	public Object get(Object key) {
		if (KEY_LUCY.equals(key)) {
			return lucy;
		} else if (lucy.getBeanDesc(key) != null) {
			return lucy.get(key);
		}
		return this.context.get(key);
	}

	@Override
	public boolean isEmpty() {
		return false;
	}

	@Override
	public Set<String> keySet() {
		return Collections.emptySet();
	}

	@Override
	public Object put(String key, Object value) {
		return this.context.put(key, value);
	}

	@Override
	public void putAll(Map<? extends String, ? extends Object> m) {
		throw new UnsupportedOperationException();
	}

	@Override
	public Object remove(Object key) {
		return this.context.remove(key);
	}

	@Override
	public int size() {
		return context.size();
	}

	@Override
	public Collection<Object> values() {
		return Collections.emptyList();
	}
}
