/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.el.mvel;

import java.io.Serializable;

import org.mvel2.MVEL;
import org.mvel2.ParserContext;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.el.AbstractLucyExpression;

/**
 * <#if locale="en">
 * <p>
 * Mvel expression for {@link Lucy}.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public class MVELExpression extends AbstractLucyExpression {

	protected Serializable compiled;

	public MVELExpression(String source) {
		this(source, new ParserContext());
	}

	public MVELExpression(String source, ParserContext parserContext) {
		super(source);
		compiled = MVEL.compileExpression(source, parserContext);
	}

	/**
	 * <#if locale="en">
	 * <p>
	 * Evaluate expression.
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 */
	@Override
	public Object evaluate(Lucy lucy) {
		return MVEL.executeExpression(compiled, new LucyComponentMap(lucy));
	}

}
