/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.impl;

import java.util.HashSet;
import java.util.Set;

import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.LucyComponentRegistrar;
import org.t2framework.lucy.config.stax.LucyConfigTagHandlerRule;
import org.t2framework.lucy.config.stax.StAXParser;

/**
 * <#if locale="en">
 * <p>
 * ComponentRegistrar for external xml configuration.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 */
public class XMLLucyComponentRegistrar implements
		LucyComponentRegistrar<String> {

	public static final String SUFFIX = ".xml";

	protected StAXParser parser = new StAXParser(new LucyConfigTagHandlerRule());

	protected Set<String> parsedPath = new HashSet<String>();

	public void setStAXParser(StAXParser parser) {
		this.parser = parser;
	}

	@Override
	public void register(Lucy lucy, String resource) {
		if (this.parsedPath.add(resource)) {
			parser.parse(lucy, resource);
		}
	}

	@Override
	public boolean accepts(Object resource) {
		if ((resource instanceof String) == false) {
			return false;
		}
		return ((String) resource).endsWith(SUFFIX);
	}
}
