/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.inject;

import org.t2framework.commons.Constants;
import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.lucy.Lucy;

/**
 * 
 * <#if locale="en">
 * <p>
 * 
 * </p>
 * <#else>
 * <p>
 * デフォルトコンストラクタのみの場合の{@link Injector}です．
 * デフォルトコンストラクタのみの場合、コンストラクタインジェクションのための情報の収集などは必要ないため、このインジェクタで代用します．
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public class SimpleConstructorInjector extends AbstractInjector<BeanDesc<?>> {

	public SimpleConstructorInjector(BeanDesc<?> container) {
		super(container);
	}

	/**
	 * <#if locale="en">
	 * <p>
	 * Simply create new instance using {@link BeanDesc#newInstance(Object...)}.
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 */
	@SuppressWarnings("unchecked")
	@Override
	public <T> T inject(T t, Lucy lucy) {
		t = (T) getConfigContainer().newInstance(Constants.EMPTY_ARRAY);
		return t;
	}

	/**
	 * <#if locale="en">
	 * <p>
	 * No setup needed.
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 */
	@Override
	protected void setup(BeanDesc<?> container) {
	}

}
