/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.ut;

import org.t2framework.commons.ut.BaseTestCase;
import org.t2framework.commons.ut.UtPlugin;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.spi.LucyConfiguration;

/**
 * <#if locale="en">
 * <p>
 * Lucy base test case.
 * 
 * </p>
 * <#else>
 * <p>
 * 
 * </p>
 * </#if>
 * 
 * @author shot
 * 
 */
public abstract class LucyTestCase extends BaseTestCase {

	protected LucyUtPlugin lucyPlugin;

	public LucyTestCase() {
	}

	/**
	 * <#if locale="en">
	 * <p>
	 * Create {@link LucyUtPlugin}.
	 * </p>
	 * <#else>
	 * <p>
	 * 
	 * </p>
	 * </#if>
	 */
	@Override
	protected UtPlugin getUtPlugin() {
		return (lucyPlugin == null) ? lucyPlugin = new LucyUtPlugin(this)
				: lucyPlugin;
	}

	protected Lucy getLucy() {
		return lucyPlugin.getLucy();
	}

	protected LucyConfiguration getLucyConfiguration() {
		return null;
	}
}
